package sun.management.snmp.jvminstr;

import com.sun.jmx.snmp.SnmpStatusException;
import java.lang.management.ManagementFactory;
import java.lang.management.CompilationMXBean;
import javax.management.MBeanServer;
import com.sun.jmx.snmp.agent.SnmpMib;
import sun.management.snmp.jvmmib.EnumJvmJITCompilerTimeMonitoring;
import sun.management.snmp.jvmmib.JvmCompilationMBean;

public class JvmCompilationImpl implements JvmCompilationMBean
{
    static final EnumJvmJITCompilerTimeMonitoring JvmJITCompilerTimeMonitoringSupported;
    static final EnumJvmJITCompilerTimeMonitoring JvmJITCompilerTimeMonitoringUnsupported;
    
    public JvmCompilationImpl(SnmpMib snmpMib) {
    }
    
    public JvmCompilationImpl(SnmpMib snmpMib, MBeanServer mBeanServer) {
    }
    
    private static CompilationMXBean getCompilationMXBean() {
        return ManagementFactory.getCompilationMXBean();
    }
    
    public EnumJvmJITCompilerTimeMonitoring getJvmJITCompilerTimeMonitoring() throws SnmpStatusException {
        if (getCompilationMXBean().isCompilationTimeMonitoringSupported()) {
            return JvmCompilationImpl.JvmJITCompilerTimeMonitoringSupported;
        }
        return JvmCompilationImpl.JvmJITCompilerTimeMonitoringUnsupported;
    }
    
    public Long getJvmJITCompilerTimeMs() throws SnmpStatusException {
        long totalCompilationTime;
        if (getCompilationMXBean().isCompilationTimeMonitoringSupported()) {
            totalCompilationTime = getCompilationMXBean().getTotalCompilationTime();
        }
        else {
            totalCompilationTime = 0L;
        }
        return new Long(totalCompilationTime);
    }
    
    public String getJvmJITCompilerName() throws SnmpStatusException {
        return JVM_MANAGEMENT_MIB_IMPL.validJavaObjectNameTC(getCompilationMXBean().getName());
    }
    
    static {
        JvmJITCompilerTimeMonitoringSupported = new EnumJvmJITCompilerTimeMonitoring("supported");
        JvmJITCompilerTimeMonitoringUnsupported = new EnumJvmJITCompilerTimeMonitoring("unsupported");
    }
}
